searchData={"items":[{"type":"module","title":"CensysEx","doc":"Root of the CensysEx lib","ref":"CensysEx.html"},{"type":"type","title":"CensysEx.result/0","doc":"Return type of CensysEx API wrappers that aren't streams","ref":"CensysEx.html#t:result/0"},{"type":"type","title":"CensysEx.result_stream/1","doc":"Return type of streaming wrappers","ref":"CensysEx.html#t:result_stream/1"},{"type":"module","title":"CensysEx.API","doc":"Base Wrapper for search.censys.io v2 APIs","ref":"CensysEx.API.html"},{"type":"function","title":"CensysEx.API.aggregate/6","doc":"","ref":"CensysEx.API.html#aggregate/6"},{"type":"function","title":"CensysEx.API.client/0","doc":"","ref":"CensysEx.API.html#client/0"},{"type":"function","title":"CensysEx.API.client/2","doc":"","ref":"CensysEx.API.html#client/2"},{"type":"function","title":"CensysEx.API.get/4","doc":"","ref":"CensysEx.API.html#get/4"},{"type":"function","title":"CensysEx.API.get_v1/4","doc":"","ref":"CensysEx.API.html#get_v1/4"},{"type":"function","title":"CensysEx.API.view/4","doc":"","ref":"CensysEx.API.html#view/4"},{"type":"opaque","title":"CensysEx.API.t/0","doc":"","ref":"CensysEx.API.html#t:t/0"},{"type":"module","title":"CensysEx.Certs","doc":"CensysEx wrapper for the search.censys.io v2 API for the \"certs\" resource","ref":"CensysEx.Certs.html"},{"type":"function","title":"CensysEx.Certs.get_hosts_by_cert/2","doc":"Hits the Censys Certs hosts API. Returns a stream of results\n\n  - API docs: https://search.censys.io/api#/certs/getHostsByCert","ref":"CensysEx.Certs.html#get_hosts_by_cert/2"},{"type":"function","title":"Examples - CensysEx.Certs.get_hosts_by_cert/2","doc":"```\nCensysEx.Certs.get_hosts_by_cert(\"fb444eb8e68437bae06232b9f5091bccff62a768ca09e92eb5c9c2cf9d17c426\")\n|> Stream.take(25)\n|> Stream.map(&Map.get(&1, \"ip\"))\n|> Enum.to_list()\n[\"10.0.0.6\", \"10.2.0.1\", ...]\n```","ref":"CensysEx.Certs.html#get_hosts_by_cert/2-examples"},{"type":"function","title":"CensysEx.Certs.view/2","doc":"Hits the Censys View Certs V1 API.\n\n  - API docs: https://search.censys.io/api#/certificates/viewCertificate","ref":"CensysEx.Certs.html#view/2"},{"type":"function","title":"Examples - CensysEx.Certs.view/2","doc":"```\nCensysEx.Certs.view(\"fb444eb8e68437bae06232b9f5091bccff62a768ca09e92eb5c9c2cf9d17c426\")\n```","ref":"CensysEx.Certs.html#view/2-examples"},{"type":"module","title":"CensysEx.Experimental","doc":"CensysEx wrapper for the search.censys.io v2 \"experimental\" APIs.\n*_NOTE_*: these APIs are subject to change in the future and CensysEx may get out of sync with Censys","ref":"CensysEx.Experimental.html"},{"type":"function","title":"CensysEx.Experimental.host_events/6","doc":"Hits the Experimental Censys host events API\n\n  - API docs: https://search.censys.io/api#/experimental/viewHostEvents","ref":"CensysEx.Experimental.html#host_events/6"},{"type":"function","title":"Examples - CensysEx.Experimental.host_events/6","doc":"```\nCensysEx.Experimental.host_events(\"127.0.0.1\")\n|> Stream.take(25)\n|> Stream.map(&Map.get(&1, \"_event\"))\n|> Enum.to_list()\n[\"service_observed\", \"location_updated\", ...]\n```","ref":"CensysEx.Experimental.html#host_events/6-examples"},{"type":"module","title":"CensysEx.Hosts","doc":"CensysEx wrapper for the search.censys.io v2 API for the \"hosts\" resource","ref":"CensysEx.Hosts.html"},{"type":"function","title":"CensysEx.Hosts.aggregate/5","doc":"Hits the Censys Hosts aggregate API. Optionally control number of buckets returned\n\n- API docs: https://search.censys.io/api#/hosts/aggregateHosts","ref":"CensysEx.Hosts.html#aggregate/5"},{"type":"function","title":"Examples - CensysEx.Hosts.aggregate/5","doc":"```\nCensysEx.Hosts.aggregate(\"location.country_code\", \"services.service_name: MEMCACHED\")\n\nCensysEx.Hosts.aggregate(\"location.country_code\", \"services.service_name: MEMCACHED\", 1000)\n```","ref":"CensysEx.Hosts.html#aggregate/5-examples"},{"type":"function","title":"CensysEx.Hosts.diff/5","doc":"Hits the Censys Hosts diff API.\n\n- API docs: https://search.censys.io/api#/hosts/viewHostDiff","ref":"CensysEx.Hosts.html#diff/5"},{"type":"function","title":"Examples - CensysEx.Hosts.diff/5","doc":"```\n# diff the current host with it self 🤷\nCensysEx.Hosts.diff(\"8.8.8.8\")\n\n# diff two hosts\nCensysEx.Hosts.diff(\"8.8.8.8\", \"1.1.1.1\")\n\n# diff a host with itself at a time in the past\nCensysEx.Hosts.diff(\"8.8.8.8\", nil, ~U[2021-06-07 12:53:27.450073Z])\n\n# diff two hosts in the past\nCensysEx.Hosts.diff(\"8.8.8.8\", \"8.8.4.4\" ~U[2021-06-07 12:53:27.450073Z], ~U[2021-06-07 12:53:27.450073Z])\n```","ref":"CensysEx.Hosts.html#diff/5-examples"},{"type":"function","title":"CensysEx.Hosts.names/2","doc":"Hits the Censys Hosts view names API. Returning a stream of names for that IP.\n\n- API docs: https://search.censys.io/api#/hosts/viewHostNames","ref":"CensysEx.Hosts.html#names/2"},{"type":"function","title":"Examples - CensysEx.Hosts.names/2","doc":"```\nCensysEx.Hosts.names(\"127.0.0.1\")\n```","ref":"CensysEx.Hosts.html#names/2-examples"},{"type":"function","title":"CensysEx.Hosts.search/4","doc":"Hits the Censys Hosts search API. Returns a stream of results for your query\n\n  - API docs: https://search.censys.io/api#/hosts/searchHosts\n  - Syntax: https://search.censys.io/search/language?resource=hosts","ref":"CensysEx.Hosts.html#search/4"},{"type":"function","title":"Examples - CensysEx.Hosts.search/4","doc":"```\nCensysEx.Hosts.search(\"same_service(service_name: SSH and not port: 22)\")\n|> Stream.take(25)\n|> Stream.map(&Map.get(&1, \"ip\"))\n|> Enum.to_list()\n[\"10.0.0.6\", \"10.2.0.1\", ...]\n```","ref":"CensysEx.Hosts.html#search/4-examples"},{"type":"function","title":"CensysEx.Hosts.view/3","doc":"Hits the Censys Hosts view API. Returning full\ninformation about an IP at a given time\n\n- API docs: https://search.censys.io/api#/hosts/viewHost","ref":"CensysEx.Hosts.html#view/3"},{"type":"function","title":"Examples - CensysEx.Hosts.view/3","doc":"```\nCensysEx.Hosts.view(\"127.0.0.1\")\n\n# View \"127.0.0.1\" at a certain time\nCensysEx.Hosts.view(\"127.0.0.1\", ~U[2021-06-07 12:53:27.450073Z])\n```","ref":"CensysEx.Hosts.html#view/3-examples"},{"type":"type","title":"CensysEx.Hosts.v_hosts/0","doc":"Values that determine how to query Virtual Hosts. `:exclude` will ignore any virtual hosts\nentries, `:include` virtual hosts will be present in the returned list of hits, `:only` will\nreturn only virtual hosts","ref":"CensysEx.Hosts.html#t:v_hosts/0"},{"type":"module","title":"CensysEx.Metadata","doc":"Functions related to the /metadata endpoints on search.censys.io","ref":"CensysEx.Metadata.html"},{"type":"function","title":"CensysEx.Metadata.hosts_metadata/1","doc":"hits metadata/hosts returning the possible values for the services.service_name field in search queries.\n\n- API docs: https://search.censys.io/api#/hosts/getHostMetadata","ref":"CensysEx.Metadata.html#hosts_metadata/1"},{"type":"module","title":"CensysEx.Paginate","doc":"CensysEx.Paginate implements a wrapper for cursor paginated APIs","ref":"CensysEx.Paginate.html"},{"type":"function","title":"CensysEx.Paginate.stream/4","doc":"","ref":"CensysEx.Paginate.html#stream/4"},{"type":"type","title":"CensysEx.Paginate.next_page_fn/0","doc":"function that takes in a keyword list of query params and returns either a map of results or an error","ref":"CensysEx.Paginate.html#t:next_page_fn/0"},{"type":"type","title":"CensysEx.Paginate.result_extractor/0","doc":"function that takes in the internal results of paginated API calls, returning a [any]","ref":"CensysEx.Paginate.html#t:result_extractor/0"},{"type":"type","title":"CensysEx.Paginate.t/0","doc":"struct to maintain the state of a paginated api call","ref":"CensysEx.Paginate.html#t:t/0"},{"type":"module","title":"CensysEx.Search","doc":"Search API V2 Specific wrapper around CensysEx.Paginate","ref":"CensysEx.Search.html"},{"type":"function","title":"CensysEx.Search.search/5","doc":"","ref":"CensysEx.Search.html#search/5"},{"type":"exception","title":"CensysEx.Exception","doc":"","ref":"CensysEx.Exception.html"},{"type":"extras","title":"CensysEx","doc":"# CensysEx\n\nTiny Elixir ⚗️ wrapper for the Censys Search 2.0 [API](https://search.censys.io/api)\n\n[![ci](https://github.com/bwireman/censys_ex/actions/workflows/elixir.yml/badge.svg?branch=main)](https://github.com/bwireman/censys_ex/actions/workflows/elixir.yml)\n[![mit](https://img.shields.io/github/license/bwireman/censys_ex?color=brightgreen)](https://github.com/bwireman/censys_ex/blob/main/LICENSE)\n[![commits](https://img.shields.io/github/last-commit/bwireman/censys_ex)](https://github.com/bwireman/censys_ex/commit/main)\n[![2.0.0](https://img.shields.io/hexpm/v/censys_ex?color=brightgreen&style=flat)](https://hexdocs.pm/censys_ex/readme.html)\n[![downloads](https://img.shields.io/hexpm/dt/censys_ex?color=brightgreen)](https://hex.pm/packages/censys_ex/)\n[![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen)](http://makeapullrequest.com)\n![Sick as hell](https://img.shields.io/badge/Sick-as%20hell%20%F0%9F%A4%98-red)\n\n_**Note**_: this is **_NOT_** an official Censys library, and is not supported by or affiliated with Censys at this time. I do not own Censys Trademarks or Copyrights","ref":"readme.html"},{"type":"extras","title":"Installation - CensysEx","doc":"Available in [Hex](https://hex.pm/packages/censys_ex), the package can be installed by adding `censys_ex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:censys_ex, \"~> 2.0.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Setup - CensysEx","doc":"via Application variables\n\n```elixir\nconfig :censys_ex,\n  api_id: \"*****\",\n  api_key: \"*****\"\n\n# ...\n\nCensysEx.API.client()\n```\n\nor directly\n\n```elixir\nCensysEx.API.client(\"*****\", \"*****\")\n```\n\nAPI secrets can be found [here](https://search.censys.io/account/api)","ref":"readme.html#setup"},{"type":"extras","title":"Hosts - CensysEx","doc":"#","ref":"readme.html#hosts"},{"type":"extras","title":"View a host - CensysEx","doc":"View all the data on an IP at a given time.\n\n```elixir\nCensysEx.Hosts.view(\"127.0.0.1\")\n\n# Lookup the host as it was at a certain time\nCensysEx.Hosts.view(\"127.0.0.1\", ~U[2021-06-07 12:53:27.450073Z])\n```\n\n#","ref":"readme.html#view-a-host"},{"type":"extras","title":"Get host names - CensysEx","doc":"Returns a stream of names for that IP.\n\n```elixir\niex(1)> CensysEx.Hosts.names(\"127.0.0.1\") |>\n...(1)> Stream.take(25) |>\n...(1)> Enum.to_list()\n[\"example.com\", \"foo.net\", ...]\n```\n\n#","ref":"readme.html#get-host-names"},{"type":"extras","title":"Search hosts - CensysEx","doc":"Search returns a stream of results using the cursors provided by the API.\n\n```elixir\niex(1)> CensysEx.Hosts.search(\"same_service(service_name: SSH and not port: 22)\") |>\n...(1)> Stream.take(25) |>\n...(1)> Stream.map(&Map.get(&1, \"ip\")) |>\n...(1)> Enum.to_list()\n[\"10.0.0.6\", \"10.2.0.1\", ...]\n```\n\n#","ref":"readme.html#search-hosts"},{"type":"extras","title":"Aggregate hosts - CensysEx","doc":"Aggregate data about hosts on the internet.\n\n```elixir\nCensysEx.Hosts.aggregate(\"location.country_code\", \"services.service_name: MEMCACHED\")\n\nCensysEx.Hosts.aggregate(\"location.country_code\", \"services.service_name: MEMCACHED\", 10)\n```\n\n#","ref":"readme.html#aggregate-hosts"},{"type":"extras","title":"Diff hosts - CensysEx","doc":"Diff hosts at given times\n\n```elixir\n# diff the current host with it self 🤷\nCensysEx.Hosts.diff(\"8.8.8.8\")\n\n# diff two hosts\nCensysEx.Hosts.diff(\"8.8.8.8\", \"1.1.1.1\")\n\n# diff a host with itself at a time in the past\nCensysEx.Hosts.diff(\"8.8.8.8\", nil, ~U[2021-06-07 12:53:27.450073Z])\n\n# diff two hosts in the past\nCensysEx.Hosts.diff(\"8.8.8.8\", \"8.8.4.4\" ~U[2021-06-07 12:53:27.450073Z], ~U[2021-06-07 12:53:27.450073Z])\n```\n\n#","ref":"readme.html#diff-hosts"},{"type":"extras","title":"Hosts API Docs - CensysEx","doc":"- [view](https://search.censys.io/api#/hosts/viewHost)\n- [names](https://search.censys.io/api#/hosts/viewHostNames)\n- [aggregate](https://search.censys.io/api#/hosts/aggregateHosts)\n- [diff](https://search.censys.io/api#/hosts/viewHostDiff)\n- [search](https://search.censys.io/api#/hosts/searchHosts)\n- [search-syntax](https://search.censys.io/search/language?resource=hosts)","ref":"readme.html#hosts-api-docs"},{"type":"extras","title":"Certs - CensysEx","doc":"#","ref":"readme.html#certs"},{"type":"extras","title":"View a cert by fingerprint - CensysEx","doc":"```elixir\n# NOTE this actually a V1 API\nCensysEx.Certs.view(\"fb444eb8e68437bae06232b9f5091bccff62a768ca09e92eb5c9c2cf9d17c426\")\n```\n\n#","ref":"readme.html#view-a-cert-by-fingerprint"},{"type":"extras","title":"Get hosts that present a cert - CensysEx","doc":"```elixir\nCensysEx.Certs.get_hosts_by_cert(\"fb444eb8e68437bae06232b9f5091bccff62a768ca09e92eb5c9c2cf9d17c426\")\n|> Stream.take(25)\n|> Stream.map(&Map.get(&1, \"ip\"))\n|> Enum.to_list()\n[\"10.0.0.6\", \"10.2.0.1\", ...]\n```\n\n#","ref":"readme.html#get-hosts-that-present-a-cert"},{"type":"extras","title":"Certs API Docs - CensysEx","doc":"- [View](https://search.censys.io/api#/certificates/viewCertificate)\n- [hosts](https://search.censys.io/api#/certs/getHostsByCert)\n\n#","ref":"readme.html#certs-api-docs"},{"type":"extras","title":"Experimental - CensysEx","doc":"```elixir\nCensysEx.Experimental.host_events(\"127.0.0.1\")\n|> Stream.take(25)\n|> Stream.map(&Map.get(&1, \"_event\"))\n|> Enum.to_list()\n[\"service_observed\", \"location_updated\", ...]\n```\n\n#","ref":"readme.html#experimental"},{"type":"extras","title":"Experimental V2 API Docs - CensysEx","doc":"- [events](https://search.censys.io/api#/experimental/viewHostEvents)","ref":"readme.html#experimental-v2-api-docs"},{"type":"extras","title":"Metadata - CensysEx","doc":"```elixir\nCensysEX.Metadata.host_metadata()\n{:ok, %{\n  \"code\": 200,\n  \"status\": \"OK\",\n  \"result\": {\n    \"services\": [\n      \"HTTP\",\n      \"IMAP\",\n      \"MQTT\",\n      \"SSH\",\n      \"...\"\n    ]\n  }\n}}\n```\n\n#","ref":"readme.html#metadata"},{"type":"extras","title":"Metadata API Docs - CensysEx","doc":"- [hosts metadata](https://search.censys.io/api#/metadata/getHostMetadata)\n\n---","ref":"readme.html#metadata-api-docs"},{"type":"extras","title":"Other Languages - CensysEx","doc":"#","ref":"readme.html#other-languages"},{"type":"extras","title":"Official - CensysEx","doc":"- [Node](https://github.com/censys/censys-node-js)\n- [Python](https://github.com/censys/censys-python)\n\n#","ref":"readme.html#official"},{"type":"extras","title":"Unofficial - CensysEx","doc":"- [Ruby](https://github.com/ninoseki/censysx/)","ref":"readme.html#unofficial"}],"content_type":"text/markdown"}